//Jukebox - Manufactura digital - Javier Aguilar Parrilla 20283

#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include "pitches.h"   //Todas las posibles notas definidas se encuentran en la tab pitches.h
#include <Adafruit_NeoPixel.h>
#define PIN        11
#define NUMPIXELS   7 //Pin y cantidad de Neopixels
LiquidCrystal_I2C lcd(0x27, 16, 2); //LCD de 16 columnas y 2 filas
Adafruit_NeoPixel neos(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

int botonprev = 6;
int botonpausa = 7;
int botonnext = 12;  //Definición de botones por pin
 
int estado = 0;   //0 = botón apagado, 1 = botón presionado
int pulsador=0;   
int pulso=0;
int play= 0;  //botón para empezar la canción
int next= 0;  //botón para la siguiente canción
int prev= 0;  //botón para la canción anterior

//Notas de la primera canción
int melody1[] = {NOTE_AS3, NOTE_C4, NOTE_CS4, NOTE_AS3, NOTE_F4, NOTE_F4, NOTE_DS4, 
                NOTE_GS3, NOTE_AS3, NOTE_C4, NOTE_GS3, NOTE_DS4, NOTE_DS4, NOTE_CS4, NOTE_C4, NOTE_AS3,
                NOTE_AS3, NOTE_C4, NOTE_CS4, NOTE_AS3, NOTE_CS4, NOTE_DS4, NOTE_C4, NOTE_AS3, NOTE_GS3,
                NOTE_F3, NOTE_DS4, NOTE_CS4,
                NOTE_AS3, NOTE_C4, NOTE_CS4, NOTE_AS3, NOTE_F4, NOTE_F4, NOTE_DS4, 
                NOTE_GS3, NOTE_AS3, NOTE_C4, NOTE_GS3, NOTE_DS4, NOTE_DS4, NOTE_CS4, NOTE_C4, NOTE_AS3,
                NOTE_AS3, NOTE_C4, NOTE_CS4, NOTE_AS3, NOTE_CS4, NOTE_DS4, NOTE_C4, NOTE_AS3, NOTE_GS3,
                NOTE_F3, NOTE_DS4, NOTE_CS4};

//Tempo de la primera canción   
int noteDurations1[] = {8, 8, 8, 8, 4, 4, 3,
                       8, 8, 8, 8, 4, 4, 4, 8, 3,
                       8, 8, 8, 8, 4, 8, 8, 8, 3,
                       8, 4, 2,
                       8, 8, 8, 8, 4, 4, 3,
                       8, 8, 8, 8, 4, 4, 4, 8, 3,
                       8, 8, 8, 8, 4, 8, 8, 8, 3,
                       8, 4, 2};

//Notas de la segunda canción
int melody2[] = {NOTE_D4, NOTE_D4, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_C4, NOTE_C4, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_B3, NOTE_B3, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_AS3, NOTE_AS3, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4,
                 NOTE_D4, NOTE_D4, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_C4, NOTE_C4, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_B3, NOTE_B3, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_AS3, NOTE_AS3, NOTE_D5, NOTE_A4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_D4, NOTE_F4, NOTE_G4};

//Tempo de la segunda canción
int noteDurations2[] = {8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8,
                        8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 8, 8, 8};

//Notas de la tercera canción
int melody3[] = {NOTE_D3, NOTE_A4, NOTE_C4, NOTE_D4, NOTE_F4, NOTE_C4, NOTE_D4, 
                NOTE_D4, NOTE_D4, NOTE_G4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_F4,
                NOTE_C4, NOTE_D4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_A4, NOTE_C4, NOTE_A4,
                NOTE_F4, NOTE_G4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_A4, NOTE_D4, NOTE_C4, NOTE_F4, NOTE_F4, NOTE_D4, NOTE_D4,
                
                NOTE_D3, NOTE_A4, NOTE_C4, NOTE_D4, NOTE_F4, NOTE_C4, NOTE_D4, 
                NOTE_D4, NOTE_D4, NOTE_G4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_F4,
                NOTE_C4, NOTE_D4, NOTE_D4, NOTE_F4, NOTE_G4, NOTE_A4, NOTE_C4, NOTE_A4,
                NOTE_F4, NOTE_G4, NOTE_D4, NOTE_C4, NOTE_D4, NOTE_A4, NOTE_D4, NOTE_C4, NOTE_F4, NOTE_F4, NOTE_D4, NOTE_D4};

//Tempo de la tercera canción
int noteDurations3[] = {4, 4,   8, 8, 8,   8, 4,
                       4, 4,   8, 8, 8, 8, 8, 8, 4,
                       8,  4, 4,   8, 8, 8,   8,   4,
                       4, 8, 8, 8, 4,    4,  8, 8,   4, 8, 4, 4,
                       
                       4, 4,   8, 8, 8,   8, 4,
                       4, 4,   8, 8, 8, 8, 8, 8, 4,
                       8,  4, 4,   8, 8, 8,   8,   4,
                       4, 8, 8, 8, 4,    4,  8, 8,   4, 8, 4, 4};
                       
void setup() {
  pinMode(botonprev, INPUT);
  pinMode(botonpausa, INPUT);
  pinMode(botonnext, INPUT);                         //Declarar como INPUT cada uno de los botones
  lcd.begin();
  lcd.backlight();
  neos.begin();
  neos.setPixelColor(0, neos.Color(53, 175, 219));   //Cambio de color de NeoPixel
  neos.setPixelColor(1, neos.Color(53, 175, 219));
  neos.setPixelColor(2, neos.Color(53, 175, 219));
  neos.setPixelColor(3, neos.Color(53, 175, 219));
  neos.setPixelColor(4, neos.Color(53, 175, 219));
  neos.setPixelColor(5, neos.Color(53, 175, 219));
  neos.setPixelColor(6, neos.Color(53, 175, 219));
  neos.show();
  
 

}

void loop() {
  lcd.setCursor(0,0);
  lcd.print(": Pick song:");// Se imprime el mensaje inical para la pantalla
  next= digitalRead(6);   //Revisar si se ha apachado el botón de next
  if (next == HIGH){
    delay(500); 
    if (estado < 5 ){
      estado= estado+1;  //se le suma 1 al estado para que cambie de pantallas hacia adelante
      songmenu();
    }
   }
  prev= digitalRead(12);   //Revisar si se ha apachado el botón de previous
  if (prev == HIGH){
    delay(500); 
    estado=estado - 1;     //se le resta 1 al estado para que cambie de pantallas hacia atrás
    songmenu();
    }
  play=digitalRead(7);   //Revisar si se ha apachado el botón de play
  if ( play== HIGH){
    delay(1000);
    pulso=pulso+1;
    delay (1000);
    if (estado==1){        //Dependiendo  de el estado se le instruye que active una de las funciones de las canciones 
        Never();
    }
    else if (estado==2){
        Mega();
    }
    else if (estado==3){
        Seve();
    }
    else if (estado==4){
        Never();
    }
}
}

void songmenu(){    //Menú para imprimir los nombres de las canciones dependiendo el estado
      lcd.clear();
    if (estado==1){
      lcd.setCursor(4,1);
      lcd.print("Never G.     ");
    }  
    else if (estado==2){
      lcd.setCursor(1,1);
      lcd.print("Megalovania     ");
        
      }
    else if (estado==3){
      lcd.setCursor(1,1);
      lcd.print("Seve         ");
        
      }  
    else if (estado==4){
      estado = estado - 4;
    }
    }


void funcionPausa() {   //Si se activa la función de pausa se apagarán las neopixels y se le indica al buzzer que ponga un tono de 0
  do {
    tone(8, 0);
    lcd.setCursor (0,1);
    lcd.print("paused ||     ");
    neos.clear();
    neos.setPixelColor(0, neos.Color(0, 0, 0));
    neos.setPixelColor(1, neos.Color(0, 0, 0));
    neos.setPixelColor(2, neos.Color(0, 0, 0));
    neos.setPixelColor(3, neos.Color(0, 0, 0));
    neos.setPixelColor(4, neos.Color(0, 0, 0));
    neos.setPixelColor(5, neos.Color(0, 0, 0));
    neos.setPixelColor(6, neos.Color(0, 0, 0));
    neos.show();
  } while (digitalRead(botonpausa) == 1);
}




void Never() {  //Song: Never Gonna Give you up - by Rick Astley
 lcd.setCursor (0,0);
 lcd.print("Never gonna");
 lcd.setCursor (0,1);
 lcd.print("playing |>      ");
 delay(500);
  neos.setPixelColor(0, neos.Color(12, 232, 111));   //color de la canción
  neos.setPixelColor(1, neos.Color(12, 232, 111));
  neos.setPixelColor(2, neos.Color(12, 232, 111));
  neos.setPixelColor(3, neos.Color(12, 232, 111));
  neos.setPixelColor(4, neos.Color(512, 232, 111));
  neos.setPixelColor(5, neos.Color(12, 232, 111));
  neos.setPixelColor(6, neos.Color(12, 232, 111));
  neos.show();
    for (int thisNote=0; thisNote <56; thisNote++) {     //Reproducción de las notas y los tonos
      int noteDuration = 1000 / noteDurations1 [thisNote];
      tone(8, melody1 [thisNote], noteDuration);
      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      noTone(8);

      if (digitalRead(botonpausa) == HIGH) {
        funcionPausa();
        break;}
    } }
    
void Mega() {   //Song: Undertale - Megalovania
 lcd.setCursor (0,0);
 lcd.print("Megalovania ");
 lcd.setCursor (0,1);
 lcd.print("playing |>      ");
 delay(500);
  neos.setPixelColor(0, neos.Color(255, 247, 0));
  neos.setPixelColor(1, neos.Color(255, 247, 0));
  neos.setPixelColor(2, neos.Color(255, 247, 0));
  neos.setPixelColor(3, neos.Color(255, 247, 0));
  neos.setPixelColor(4, neos.Color(255, 247, 0));
  neos.setPixelColor(5, neos.Color(255, 247, 0));
  neos.setPixelColor(6, neos.Color(255, 247, 0));
  neos.show();
    for (int thisNote=0; thisNote <80; thisNote++) {
      int noteDuration = 1000 / noteDurations2 [thisNote];
      tone(8, melody2 [thisNote], noteDuration);
      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      noTone(8);

      if (digitalRead(botonpausa) == HIGH) {
        funcionPausa();
        break; }
      }
    }   
 
void Seve() {    //Song: Seve - by Tez Cadney
 lcd.clear();
 lcd.setCursor (0,0);
 lcd.print("Seve      ");
 lcd.setCursor (0,1);
 lcd.print("playing |>  ");
 delay(500);
  neos.setPixelColor(0, neos.Color(126, 12, 232));
  neos.setPixelColor(1, neos.Color(126, 12, 232));
  neos.setPixelColor(2, neos.Color(126, 12, 232));
  neos.setPixelColor(3, neos.Color(126, 12, 232));
  neos.setPixelColor(4, neos.Color(126, 12, 232));
  neos.setPixelColor(5, neos.Color(126, 12, 232));
  neos.setPixelColor(6, neos.Color(126, 12, 232));
  neos.show();
    for (int thisNote=0; thisNote <72; thisNote++) {
      int noteDuration = 1000 / noteDurations3 [thisNote];
      tone(8, melody3 [thisNote], noteDuration);
      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      noTone(8);
      
      if (digitalRead(botonpausa) == HIGH) {
        funcionPausa();
        break; }
    }}
